
    #include "colors.inc"
    #include "woods.inc"

#declare T_Crack2 =       //not my texture
texture {
pigment
 {granite
  turbulence 0.8
  color_map
   {[0.0, 0.5   color Clear color Clear]
    [0.5, 0.54   color Clear color Black]
    [0.54, 1.0 color Clear color Clear]
   }
 }
 }//end T_Crack2
 
#declare Dcolor = Gray40;
#declare Dtexture = T_Crack2;

#declare S_90torus = intersection{
           union{torus{0.25, 0.01}
                torus{0.75, 0.01}}
             box{<0,-1,0>,<1,1,1>}   
            }//end S_90torus
            
#declare L_90torus1 = intersection{
           union{torus{1.25, 0.01}
                torus{1.75, 0.01}}
             box{<0,-1,0>,<3,3,3>}   
            }//end S_90torus
            
#declare L_90torus2 = intersection{
           union{torus{2.25, 0.01}
                torus{2.75, 0.01}object{L_90torus1}}
             box{<0,-1,0>,<3,3,3>}   
            }//end S_90torus
            
#declare DStick = union{ // stick used on the city wall
          cylinder{ //main part of stick
        //<Base_Point>, <Cap_Point>, Radius
        <0, 0, 0>, <0, 0.8, 0>, 0.05
        texture{T_Wood2}}
        cone{
        //<Base_Point>, Base_Radius, <Cap_Point>, Cap_Radius
        <0, 0.08, 0>, 0.05
	<0, 1, 0>, 0 
	pigment{Tan}}
        }//end DStick
        
/*#macro Axis_Rotate_Trans(Axis, Angle)
   #local vX = vaxis_rotate(x,Axis,Angle);
   #local vY = vaxis_rotate(y,Axis,Angle);
   #local vZ = vaxis_rotate(z,Axis,Angle);
   transform {
      matrix < vX.x,vX.y,vX.z, vY.x,vY.y,vY.z, vZ.x,vZ.y,vZ.z, 0,0,0 >
   }
#end */

//#declare Rounded_Box = superellipsoid { <Round, Round> }


#macro Road(Where, Length, Width, Angle)
     #declare IndexZ = 0;
     //difference{ //To make ruts
     union{     //make road bed and stones behave as one
     box {<0, 0, 0>,  // Near lower left corner                     road from temple
           <Width, 0.99, Length>   // Far upper right corner y was 0.95
         pigment {Dcolor} texture{Dtexture} }
    #declare IndexZ = 0;
    #while (IndexZ <= Length)
    #declare IndexX = 0; //resets IndexX to 0 for each IndexZ loop
    #while (IndexX <= Width)
    /* superellipsoid {
    <0.5, 0.1>
    pigment { color Dcolor } normal {bumps 0.4 scale .01}
    translate <IndexX, 1, IndexZ>
    scale <0.1, 0.1, 0.01>
  }  //end superellipsoid */
    box {<IndexX, 0, IndexZ>, <IndexX + 0.19, 1, IndexZ + 0.19> //was .18
    pigment { color Dcolor } normal {bumps 0.4 scale .01}}

    #declare IndexX = IndexX + 0.20; //was .21
    #end //end of IndexX loop    
    #declare IndexZ = IndexZ + 0.20;    
    #end //end of IndexZ loop
     
     
    translate Where 
    } //end union of roads                
   // #declare IndexX = 0.25;
   // #while (IndexX <= Width)
   // cylinder{ //ruts
    //    //<Base_Point>, <Cap_Point>, Radius
    //    <IndexX, 1, 0>, <IndexX, 1, Length>, 0.015
    // texture{Dtexture}}
    //#declare IndexX = IndexX + 0.5;    
    //#end
    //rotate y*Angle 
    //translate Where
    //} //end difference of ruts
    
     
#end //of road  

#macro Pavement(Where, Length, Width, Angle)
     union{     //make road bed and stones behave as one
     #declare IndexZ = 0;
       box {<0, 0, 0>,  // Near lower left corner                     road from temple
            <Width, 0.95, Length>   // Far upper right corner
            texture{Dtexture}}
    #declare IndexZ = 0;
    #while (IndexZ <= Length)
    #declare IndexX = 0; //resets IndexX to 0 for each IndexZ loop
    #while (IndexX <= Width)
   
    box {<IndexX, 0, IndexZ>, <IndexX + 0.18, 1, IndexZ + 0.18> 
    pigment { color Dcolor } normal {bumps 0.4 scale .1}}

    #declare IndexX = IndexX + 0.21;
    #end //end of IndexX loop    
    #declare IndexZ = IndexZ + 0.21;    
    #end //end of IndexZ loop
     } end of union of pavement
   
     
 
   //translate Where 
#end //pavement